import 'package:json_annotation/json_annotation.dart';
part 'dl_response.g.dart';

/// Data class for Driver's Licence Verification  Response

@JsonSerializable(fieldRename: FieldRename.snake, explicitToJson: true)
class DLResponse {
  int statusCode;
  String status;
  String message;
  Results results;

  DLResponse(this.statusCode, this.status, this.message, this.results);

  factory DLResponse.fromJson(Map<String, dynamic> json) => _$DLResponseFromJson(json);

  Map<String, dynamic> toJson() => _$DLResponseToJson(this);


}

/// Data class for Driver's Licence Verification Result Response

@JsonSerializable(fieldRename: FieldRename.snake, explicitToJson: true)
class Results {
  String requestReference;
  String licenceNumber;
  String previousLicenceNumber;
  String licenceClass;
  String licenceDescription;
  String dateOfFirstIssuance;
  String stateOfFirstIssuance;
  String stateOfIssuance;
  String dateOfIssuance;
  String dateOfExpiration;
  String verificationStatus;
  String serviceType;
  PersonalInfo personalInfo;
  ResidentialInfo residentialInfo;
  NextOfKin nextOfKin;

  Results(this.requestReference, this.licenceNumber, this.previousLicenceNumber,
      this.licenceClass, this.licenceDescription, this.dateOfFirstIssuance,
      this.stateOfFirstIssuance, this.stateOfIssuance, this.dateOfIssuance,
      this.dateOfExpiration, this.verificationStatus, this.serviceType,
      this.personalInfo, this.residentialInfo, this.nextOfKin);


  factory Results.fromJson(Map<String, dynamic> json) => _$ResultsFromJson(json);

  Map<String, dynamic> toJson() => _$ResultsToJson(this);


}

/// Data class for Driver's Licence Verification Next Of Kin Response

@JsonSerializable(fieldRename: FieldRename.snake, explicitToJson: true)
class NextOfKin {
  String nextOfKinPhoneNumber, motherMaidenName;

  NextOfKin(this.nextOfKinPhoneNumber, this.motherMaidenName);

  factory NextOfKin.fromJson( Map<String, dynamic> json) => _$NextOfKinFromJson(json);

  Map<String, dynamic> toJson() => _$NextOfKinToJson(this);


}

/// Data class for Driver's Licence Verification Residential Info Response

@JsonSerializable(fieldRename: FieldRename.snake, explicitToJson: true)
class ResidentialInfo {
  String homeAddress, residenceLga, residenceState;

  ResidentialInfo(this.homeAddress, this.residenceLga, this.residenceState);

  factory ResidentialInfo.fromJson( Map<String, dynamic> json) => _$ResidentialInfoFromJson(json);

  Map<String, dynamic> toJson() => _$ResidentialInfoToJson(this);


}

/// Data class for Driver's Licence Verification Personal Info Response

@JsonSerializable(fieldRename: FieldRename.snake, explicitToJson: true)
class PersonalInfo {
  String firstName;
  String middleName;
  String lastName;
  String fullName;
  String gender;
  String height;
  String lgaOfOrigin;
  String stateOfBirth;
  String countryOfBirth;
  String facialMark;
  String disability;
  String glasses;
  String dateOfBirth;
  String formattedDateOfBirth;
  String mobileNumber;
  String imageUrl;

  PersonalInfo(this.firstName, this.middleName, this.lastName, this.fullName,
      this.gender, this.height, this.lgaOfOrigin, this.stateOfBirth,
      this.countryOfBirth, this.facialMark, this.disability, this.glasses,
      this.dateOfBirth, this.formattedDateOfBirth, this.mobileNumber,
      this.imageUrl);

  factory PersonalInfo.fromJson( Map<String, dynamic> json) => _$PersonalInfoFromJson(json);

  Map<String, dynamic>  toJson() => _$PersonalInfoToJson(this);


}