import 'package:json_annotation/json_annotation.dart';
part 'initialization_response.g.dart';

@JsonSerializable(fieldRename: FieldRename.snake, explicitToJson: true)
class InitializationResponse {
  int statusCode;
  String status;
  String message;
  Result result;

  InitializationResponse(this.statusCode, this.status, this.message,
      this.result);

  factory InitializationResponse.fromJson(Map<String, dynamic> json) => _$InitializationResponseFromJson(json);

  Map<String, dynamic> toJson() => _$InitializationResponseToJson(this);

}

@JsonSerializable(fieldRename: FieldRename.snake, explicitToJson: true)
class Result {
  bool isCredentialValid;
  List<Services> services;
  //List<IdValidationLicense> idValidationLicense;
  String bundleCallId;

  Result(this.isCredentialValid, this.services,this.bundleCallId);
  
  factory Result.fromJson(Map<String, dynamic> json) => _$ResultFromJson(json);
  
  Map<String, dynamic> toJson() => _$ResultToJson(this);


}

@JsonSerializable(fieldRename: FieldRename.snake, explicitToJson: true)
class IdValidationLicense {
  String androidValidationLicense;
  String iosValidationLicense;

  IdValidationLicense(this.androidValidationLicense, this.iosValidationLicense);
  
  factory IdValidationLicense.fromJson(Map<String, dynamic> json) =>_$IdValidationLicenseFromJson(json);
  Map<String, dynamic> toJson() =>_$IdValidationLicenseToJson(this);


}
@JsonSerializable(fieldRename: FieldRename.snake, explicitToJson: true)
class Services {
  int id;
  String serviceLabel;

  Services(this.id, this.serviceLabel);

  factory Services.fromJson(Map<String, String> json) => _$ServicesFromJson(json);

  Map<String, dynamic> toJson() => _$ServicesToJson(this);

}