import 'package:json_annotation/json_annotation.dart';
part 'nip_response.g.dart';

/// Data class for NIP Verification Response

@JsonSerializable(fieldRename: FieldRename.snake, explicitToJson: true)
class NIPResponse {
  int statusCode;
  String status;
  String message;
  Results results;

  NIPResponse(this.statusCode, this.status, this.message, this.results);

  factory NIPResponse.fromJson(Map<String, dynamic> json) => _$NIPResponseFromJson(json);

  Map<String, dynamic> toJson() => _$NIPResponseToJson(this);

}

/// Data class for NIP Verification Result Response

@JsonSerializable(fieldRename: FieldRename.snake, explicitToJson: true)
class Results {
  String requestReference;
  String passportNumber;
  String placeOfIssuance;
  String dateOfIssuance;
  String passportExpirationDate;
  String verificationStatus;
  String serviceType;
  PersonalInfo personalInfo;

  Results(this.requestReference, this.passportNumber, this.placeOfIssuance,
      this.dateOfIssuance, this.passportExpirationDate, this.verificationStatus,
      this.serviceType, this.personalInfo);

  factory Results.fromJson(Map<String, dynamic> json) => _$ResultsFromJson(json);

  Map<String, dynamic> toJson() => _$ResultsToJson(this);


}

/// Data class for NIP Verification Personal Info Response

@JsonSerializable(fieldRename: FieldRename.snake, explicitToJson: true)
class PersonalInfo {
  String firstName;
  String middleName;
  String lastName;
  String fullName;
  String email;
  String gender;
  String phoneNumber;
  String dateOfBirth;
  String formattedDateOfBirth;
  String imageUrl;

  PersonalInfo(this.firstName, this.middleName, this.lastName, this.fullName,
      this.email, this.gender, this.phoneNumber, this.dateOfBirth,
      this.formattedDateOfBirth, this.imageUrl);

  factory PersonalInfo.fromJson(Map<String, dynamic> json) => _$PersonalInfoFromJson(json);
  
  Map<String, dynamic> toJson() => _$PersonalInfoToJson(this);

}