import 'package:json_annotation/json_annotation.dart';
part 'pvc_response.g.dart';

/// Data class for PVC Verification Response

@JsonSerializable(fieldRename: FieldRename.snake, explicitToJson: true)
class PVCResponse {
  int statusCode;
  String status;
  String message;
  Results results;

  PVCResponse(this.statusCode, this.status, this.message, this.results);

  factory PVCResponse.fromJson(Map<String, dynamic> json) => _$PVCResponseFromJson(json);

  Map<String, dynamic> toJson() => _$PVCResponseToJson(this);


}

/// Data class for PVC Verification Result Response

@JsonSerializable(fieldRename: FieldRename.snake, explicitToJson: true)
class Results {
  String requestReference;
  String pvcNumber;
  String verificationStatus;
  String serviceType;
  PersonalInfo personalInfo;
  PollingUnitInfo pollingUnitInfo;

  Results(this.requestReference, this.pvcNumber, this.verificationStatus,
      this.serviceType, this.personalInfo, this.pollingUnitInfo);
  
  factory Results.fromJson(Map<String, dynamic> json) => _$ResultsFromJson(json);
  
  Map<String, dynamic> toJson() => _$ResultsToJson(this);


}

/// Data class for PVC Verification Polling Unit Info  Response

@JsonSerializable(fieldRename: FieldRename.snake, explicitToJson: true)
class PollingUnitInfo {
  String pollingUnitId;
  String pollingUnit;
  String pollingWard;
  String pollingLga;
  String pollingDelimitation;

  PollingUnitInfo(this.pollingUnitId, this.pollingUnit, this.pollingWard,
      this.pollingLga, this.pollingDelimitation);
  
  factory PollingUnitInfo.fromJson(Map<String, dynamic> json) => _$PollingUnitInfoFromJson(json);
  
  Map<String, dynamic> toJson()=> _$PollingUnitInfoToJson(this);
}
/// Data class for PVC Verification Personal Info Response

@JsonSerializable(fieldRename: FieldRename.snake, explicitToJson: true)
class PersonalInfo {
  String firstName;
  String middleName;
  String lastName;
  String fullName;
  String email;
  String phoneNumber;
  String gender;
  String dateOfBirth;
  String formattedDateOfBirth;
  String occupation;

  PersonalInfo(this.firstName, this.middleName, this.lastName, this.fullName,
      this.email, this.phoneNumber, this.gender, this.dateOfBirth,
      this.formattedDateOfBirth, this.occupation);
  
  factory PersonalInfo.fromJson(Map<String, dynamic> json) => _$PersonalInfoFromJson(json);
  
  Map<String, dynamic> toJson() => _$PersonalInfoToJson(this);


}