import 'dart:async';
import 'dart:convert';

import 'package:blusalt_identity/model/initialization_response.dart';
import 'package:blusalt_identity/network/network_client.dart';
import 'package:blusalt_identity/services.dart';

class BlusaltSDK {
  static final BlusaltSDK _instance = BlusaltSDK._internal();
  static ApiCredentials apiCredentials;

  factory BlusaltSDK({ApiCredentials credentials}) {
    apiCredentials = credentials;
    return _instance;
  }

  static Future<dynamic> initializeSDK(ApiCredentials credentials) {
    BlusaltSDK(credentials: credentials);
    var client = new HttpClient();
    var future = client.initializeSDK(credentials);
    future.then((onValue) {
      InitializationResponse response =
          InitializationResponse.fromJson(jsonDecode(onValue.body));
      if(response.statusCode == 200){
        var services = response.result.services;
        services.forEach((it){
         // _services.add();
        });
        return Future.value(response);
      }
      else return future;
    });
    return future;

    //return client.initializeSDK(apiCredentials);
  }

  BlusaltSDK._internal() {}
}
